package proxy;


import java.lang.*;
import java.net.*;
import java.io.*;
import agentsystem.Command;


public class PrServer extends Thread {

private ServerSocket SSock; 



  PrServer(ServerSocket SS){

    SSock = SS;
  }


  public void run(){

    for(;;){ 
      try {
	Socket sock = SSock.accept();

	// Servitore sequenziale per ridurre uso risorse..
	// si puo' rendere facilmente parallelo per migliorare prestazioni

	InputStream Stin = sock.getInputStream();
	ObjectInputStream In = new ObjectInputStream(Stin);

	// Aperta connessione ora leggo indirizzo
	Address dest= (Address) In.readObject();

	// Ora leggo oggetto
        Command c = (Command) In.readObject();

	// chiudo connessione ed apro la quella per la spedizione
	sock.close();

	System.err.println("Apro connessione:"+dest.Addr+":"+dest.Port); 
	sock=new Socket(dest.Addr,dest.Port);
	//	sock=new Socket(,dest.Port);      
        OutputStream Stout = sock.getOutputStream();
     	ObjectOutputStream Out = new ObjectOutputStream(Stout);

	// scrivo oggetto al destinatario
        Out.writeObject(c);

	Out.flush();
	sock.close();

// e' evidente che c viene serializzato e deserializzato senza reale 
// necessita' ... cosi' pero' il codice e' semplicissimo.   

      } catch (Exception e) {
	e.printStackTrace();
	stop();
      }
      
    }


  }
}
