package proxy;

import java.lang.*;
import java.io.*;
import java.net.*;

/** Demone  che esegue funzioni di Proxy per la comunicazione tra Domini
  * fisicamente separati.
  * Si mette in ricezione su le due o piu' connessioni e si occupa del 
  * e si occupa del forwarding dei messaggi.
  * Il protocollo e' semplice: devono arrivare due oggetti: il primo di tipo
  * InetAddress contiene la destinazione, il secondo e' il messaggio da 
  * trasferire. 
  */



public class Proxy{

 


public static void main(String[] args){
  
  String sIaddr;
  String sEaddr;
  String sPort;
  InetAddress Iaddr,Eaddr;
  int Port;

  int port;
  
  if (args.length<= 0){
    System.out.println("Usage: java Proxy internalhost externalhost servport");
    return;
  } 

  try{
    sIaddr = args[0];
    sEaddr = args[1];
    sPort = args[2];
    Iaddr = InetAddress.getByName(sIaddr);
    Eaddr = InetAddress.getByName(sEaddr);
    Port = (new Integer(sPort)).intValue();
      
    System.out.println("Internal Addr "+sIaddr+" External Addr "+sEaddr+" Port "+Port);

    System.out.println("Starting Servers...");
    
  } catch (Exception e){
    e.printStackTrace();
    System.out.println("Usage: java Proxy internalhost externalhost servport");
    return;
  }
  

  
  ServerSocket ISSock= null; 
  Socket ISock;
  ServerSocket ESSock= null; 
  Socket ESock;

  try {
    ISSock = new ServerSocket(Port,10,Iaddr);

    System.err.println("Proxy: apro server socket alla porta "+Port+"+1");

    ESSock = new ServerSocket(Port+1,10,Eaddr); // modifica per prova +1
 
  } catch (Exception e) {
    e.printStackTrace();
  System.out.println("Non riesco aprire ServerSocket");
  }

  System.err.println("SocketServer ready ");

 

  
  PrServer IS= new PrServer(ISSock);
  PrServer ES= new PrServer(ESSock); // non puo' andare sulla 
  // stessa scheda perche' in due possono fare un solo bind !!!

 
  IS.start();
  ES.start();

  

  System.out.println("Proxy ready.");


 
}


}
